﻿enyo.kind({
    name: "enyo.MainView",
    kind: enyo.VFlexBox,
    components: [
    // services
	    {name: "openApp", kind: "PalmService", service: "palm://com.palm.applicationManager/", method: "open" },
        { name: "blueGps", kind: "enyo.SPPGPS",
            onDeviceFound: "blueGpsDeviceFound",
            onChooseDevice: "blueGpsChooseDevice",
            onDeviceConnected: "blueGpsDeviceConnected",
            onDeviceDisconnected: "blueGpsDeviceDisconnected",
            onLocationFound: "blueGpsLocationFound",
            onSignalLost: "blueGpsSignalLost"
        },
        { name: "googleGps", kind: "enyo.GoogleGPS", onLocated: "googleGpsLocationFound", onFailed: "googleGpsFailed" },

    // controls
        {kind: "AppMenu", components: [
                { caption: "About", onclick: "onMenuAbout" },
                { caption: "Settings", onclick: "onMenuSettings" },
                { caption: "Exit", onclick: "onMenuExit" }
            ]
    },
        { kind: "Pane", flex: 1, transitionKind: "enyo.transitions.Simple", components: [
            { kind: enyo.VFlexBox, components: [
                { name: "dlgChooseBlueGps", kind: "enyo.DialogChooseBluetoothGps", onChoosen: "choosenDone" },
		        { name: "slidingPane", kind: "SlidingPane", flex: 1, components: [
			        { name: "left", width: "200px", components: [
				        { kind: "VFlexBox", flex: 1, components: [
					        { kind: "Item", layoutKind: "HFlexLayout", align: "left", components: [
							        { content: $L("Traffic"), flex: 1, style: "padding-left: 10px;padding-right: 10px;" },
                                    { name: "btnTraffic", kind: "ToggleButton", onLabel: "on", offLabel: "off", onChange: "buttonToggleTraffic" }
					        ]
					        },
                            { name: "divider", kind: "Divider", caption: "Layers", showing: true },
					        { name: "list", kind: "VirtualList", flex: 1, onSetupRow: "listSetupRow", components: [
						        { kind: "Item", layoutKind: "HFlexLayout", align: "left", onclick: "itemClick", components: [
							            { name: "name", flex: 1, style: "padding-left: 10px;padding-right: 10px;" },
                                        { name: "btnOn", kind: "CheckBox", caption: "on" }
						        ]
						        }
					        ]
					        },
				        ]
				        }
			        ]
			        },
			        { name: "right", flex: 1, dragAnywhere: false, onResize: "slidingResize", components: [
				        { kind: "VFlexBox", flex: 1, components: [
					        { name: "map", kind: "enyo.YandexMap", showing: true,
					            mapType: "yandex#map", zoom: 10,
					            onConnectionAvail: "connectionAvail", onConnectionFailure: "connectionFailure",
					            onCenterChanged: "mapCenterChanged"
					        },
                            { tag: "div", name: "ymapsdiv", style: "width:100%; height:100%; background-color:#f8f8f8;",
                                components: [
                                    { name: "noconn", kind: "Image", src: "images/no-wifi.png", showing: false,
                                        width: "110px", height: "98px", className: "centeredImage"
                                    },
                            ]
                            },
                            { name: "btnGps", kind: "Image", src: "images/status_bar_inactive.png",
                                className: "btnGps", width: "48px", height: "48px",
                                onclick: "btnGpsClick"
                            },
				        ]
				        },
				        { kind: "Toolbar", className: "enyo-toolbar-light", components: [
					        { kind: "GrabButton" },
                            { kind: "Image", src: "images/where_am_i.png", onclick: "findmeClick" }
				        ]
				        }
			        ]
			        }
                ]
		        }
		    ]
            },
            { name: "sview", kind: "SettingsView", onBack: "onSettingBack", onLoaded: "onSettingsLoaded" }
            ]
        },
        { name: "aboutDialog", kind: "ModalDialog", caption: $L("О программе"), width: "450px", components: [
		    { kind: "HFlexBox", components: [
	            { components: [
		            { kind: "Image", src: 'images/about_icon.png', style: "margin-left: 20px;margin-right: 10px" }
			    ]
	            },
			    { components: [
			        { content: $L("Яндекс.Карты для WebOS"), className: 'enyo-text-subheader enyo-text-ellipsis' },
	                { content: $L("Версия " + enyo.fetchAppInfo().version), className: 'enyo-text-ellipsis enyo-subtext' }
			    ]
			    }
	        ]
		    },
            { layoutKind: "HFlexLayout", pack: "center", components: [
                { kind: "Button", caption: "OK", width: "120px", onclick: "okClick" },
            ]
            }
        ]
        }
	],
    menuItems: [
		{ name: "Yandex", id: "yandex" },
        { name: "Google", id: "google" },
        { name: "OSM", id: "osm" }
	],

    layerSelected: "yandex",

    rendered: function () {
        this.inherited(arguments);
    },

    getSettings: function () {
        return this.$.sview.$.settings;
    },

    // ======================================== GPS handling ==================================================

    gpsTurnedOn: false,
    btnGpsClick: function () {
        console.log("btnGps click");
        if (!this.gpsTurnedOn) {

            this.turnOnGps();
            this.startAnimation();
        }
        else {
            this.turnOffGps();
            this.stopAnimation();
        }
    },

    turnOnGps: function () {
        this.$.map.gpsPositionHide();
        switch (this.getSettings().selectedGpsType) {
            case "google":
                this.$.googleGps.getPosition();
                break;
            case "internal":
                this.$.googleGps.startTracking();
                break;
            case "external":
                this.$.blueGps.connect();
                break;
        }
        this.gpsTurnedOn = true;
    },

    turnOffGps: function () {
        this.$.map.gpsPositionHide();
        this.$.btnGps.setSrc("images/status_bar_inactive.png");

        switch (this.getSettings().selectedGpsType) {
            case "google":
                break;
            case "internal":
                // TODO: stop tracking
                //this.$.googleGps.stopTracking();
                break;
            case "external":
                this.$.blueGps.disconnect();
                break;
        }
        this.gpsTurnedOn = false;
    },

    step: 1,
    gpsIsAnimated: false,
    startAnimation: function () {
        this.gpsIsAnimated = true;
        this.step = 1;
        window.setTimeout(enyo.hitch(this, "stepAnimation"), 500);
    },
    stopAnimation: function () {
        this.gpsIsAnimated = false;
    },
    stepAnimation: function () {
        if (this.gpsIsAnimated) {
            this.step++;
            if (this.step > 6) this.step = 1;
            this.$.btnGps.setSrc("images/status_bar_active_" + this.step + ".png");
            window.setTimeout(enyo.hitch(this, "stepAnimation"), 500);
        }
        else {
            if (this.gpsTurnedOn)
                this.$.btnGps.setSrc("images/status_bar_active.png");
            else
                this.$.btnGps.setSrc("images/status_bar_inactive.png");
        }
    },

    // ====================================== BLUETOOTH GPS ===============================================

    retryCount: 5,
    // Bluetooth GPS event handlers
    blueGpsDeviceFound: function (inSender, deviceInfo) {
        enyo.windows.addBannerMessage("Bluetooth GPS found: " + deviceInfo.name, "{}", "{}", "notification");
    },
    blueGpsChooseDevice: function (inSender, deviceList) {
        if (deviceList !== null) {
            if (this.gpsTurnedOn)
                this.$.dlgChooseBlueGps.show(deviceList);
        }
    },
    blueGpsDeviceConnected: function (inSender, deviceInfo) {
        enyo.windows.addBannerMessage("Bluetooth GPS " + deviceInfo.name + " connected!", "{}", "{}", "notification");
    },
    blueGpsDeviceDisconnected: function () {
        enyo.windows.addBannerMessage("Bluetooth GPS disconnected.", "{}", "{}", "notification");

        if (this.retryTry == null)
            this.retryTry = this.retryCount;
        else
            this.retryTry -= 1;

        if (this.retryTry == 0) return;

        if (this.gpsTurnedOn)
            this.$.blueGps.connect();
    },
    blueGpsLocationFound: function (inSender, lat, long) {
        console.log('blueGpsLocationFound: ' + lat + '/' + long);

        this.gpsIsAnimated = false;
        this.$.btnGps.setSrc("images/status_bar_active.png");

        var flat = parseFloat(lat.substr(0, lat.length - 1));
        var flong = parseFloat(long.substr(0, long.length - 1))

        this.$.map.gpsPosition(flat, flong);
    },
    blueGpsSignalLost: function () {
    },

    choosenDone: function (inSender, address) {
        if (this.gpsTurnedOn)
            this.$.blueGps.subscribeDeviceService(address);
    },

    // ================================== GPS: Google & Internal ==================================================

    googleGpsLocationFound: function (inSender, inResponse) {
        console.log("gps location services [success]: " + enyo.json.stringify(inResponse));

        if (this.gpsTurnedOn) {

            if (this.getSettings().selectedGpsType == "google") {
                this.stopAnimation();
                this.turnOffGps();

                if (inResponse.errorCode == 0) {
                    this.$.map.gpsPosition(parseFloat(inResponse.latitude), parseFloat(inResponse.longitude), true);
                    this.$.map.pantoPosition();
                }
                else {
                    enyo.windows.addBannerMessage("Location is not found", "{}", "{}", "notification");
                }
            }
            else if (this.getSettings().selectedGpsType == "internal") {
                if (inResponse.returnValue) {
                    if (inResponse.errorCode == 0) {
                        this.stopAnimation();
                        this.$.map.gpsPosition(parseFloat(inResponse.latitude), parseFloat(inResponse.longitude), false);
                        this.$.map.pantoPosition();
                    }
                    else if (inResponse.errorCode > 0) {
                        enyo.windows.addBannerMessage("Location is not found", "{}", "{}", "notification");
                        this.stopAnimation();
                        this.turnOffGps();
                    }
                    else {
                        enyo.windows.addBannerMessage("Please wait for GPS fix", "{}", "{}", "notification");
                    }
                }
            }
        }
    },
    googleGpsFailed: function (inSender, inResponse) {
        console.log("gps location services [failed]: " + enyo.json.stringify(inResponse));

        if (this.gpsTurnedOn) {
            this.stopAnimation();
            this.turnOffGps();
            enyo.windows.addBannerMessage("Your current location is unavailable", "{}", "{}", "notification");
        }
    },

    // ======================================= Toolbar Menu =========================================

    findmeClick: function () {
        this.$.map.pantoPosition();
    },

    // ======================================= MAIN Menu ===========================================

    onMenuAbout: function () {
        this.openAboutDialog();
    },
    onMenuSettings: function () {
        this.$.pane.selectViewByIndex(1);
    },
    onSettingBack: function () {
        this.$.pane.selectViewByIndex(0);
    },
    onMenuExit: function () {
        window.close();
    },
    openAboutDialog: function () {
        this.$.aboutDialog.openAtCenter();
    },

    okClick: function () {
        this.$.aboutDialog.close();
    },

    // ================================== Connection ===========================================

    connected: false,
    connectionFailure: function () {
        if (this.connected) {
            enyo.windows.addBannerMessage("No internet connection is currently available", "{}", "{}", "notification");
            console.log("connectionFailure");
            this.$.noconn.show();
            this.connected = false;
        }
    },

    connectionAvail: function () {
        console.log("connectionAvail");
        this.connected = true;
        this.$.noconn.hide();
        this.showMap();
    },

    showMap: function () {
        if (!this.$.map.hasMap()) {
            if (this.connected && this.settingsLoaded)
                this.$.map.renderMap();
        }
    },
    mapCenterChanged: function (sender, e) {

        var settings = this.getSettings();

        if (settings.restorePosition) {
            settings.restorePositionZoom = this.$.map.getZoom();
            settings.restorePositionLat = parseFloat(e[0]);
            settings.restorePositionLong = parseFloat(e[1]);
            console.log('saving position, location: ' + settings.restorePositionLat + '/' + settings.restorePositionLong);
            settings.save();
        }
    },

    // ================================= LOADING SETTINGS ===========================================
    // settings values
    parameter: "",
    parameterValue: "",
    settingsLoaded: false,

    onSettingsLoaded: function (inSender, inResponse) {
        var sets = this.getSettings();

        console.log("restoring settings");

        if (sets.restoreLayerSelection) {
            var rlayer = sets.restoreLayerValue == "" ? "yandex" : sets.restoreLayerValue;
            console.log("restoring layer: " + rlayer);
            this.changeLayer(rlayer);
        }
        if (sets.restorePosition) {
            console.log("restoring position, zoom: " + sets.restorePositionZoom);

            if (!isNaN(sets.restorePositionZoom) && sets.restorePositionZoom != "")
                this.$.map.setZoom(sets.restorePositionZoom);

            console.log("restoring position, location: " + sets.restorePositionLat + "/" + sets.restorePositionLong);

            if (!isNaN(sets.restorePositionLat))
                this.$.map.setCenter(sets.restorePositionLat, sets.restorePositionLong);
        }
        if (sets.disableScreenLock) {
            // disable screen lock
            window.PalmSystem.setWindowProperties({ blockScreenTimeout: true });
        }
        if (sets.restoreTrafficSelection) {
            console.log("restoring traffic: " + sets.restoreTrafficValue);
            this.$.btnTraffic.setState(sets.restoreTrafficValue == "" ? false : sets.restoreTrafficValue);
            this.$.map.shownTraffic = this.$.btnTraffic.getState();
        }

        this.settingsLoaded = true;
        this.showMap();
    },

    // =================================================================================================

    listSetupRow: function (inSender, inRow) {
        var c = this.menuItems && this.menuItems[inRow];
        if (c) {
            this.$.name.setContent(c.name);
            this.$.btnOn.setChecked(false);

            if (c.id == this.layerSelected)
                this.$.btnOn.setChecked(true);

            return true;
        }
    },
    slidingResize: function (inSender, inRow) {
        this.$.map.resizeMap();
    },
    itemClick: function (inSender, inEvent) {
        var c = this.menuItems[inEvent.rowIndex];
        if (c.id == "yandex" || c.id == "google" || c.id == "osm") {
            this.changeLayer(c.id);
        }
    },
    changeLayer: function (sid) {
        console.log("change layer: " + sid);
        this.$.map.changeLayer(sid);
        this.layerSelected = sid;

        var settings = this.getSettings();
        if (settings.restoreLayerSelection && settings.restoreLayerValue !== sid) {
            settings.restoreLayerValue = sid;
            settings.save();
        }
        this.$.list.refresh();
    },
    buttonToggleTraffic: function (inSender, inState) {

        if (this.$.map.shownTraffic)
            this.$.map.hideTraffic();
        else
            this.$.map.showTraffic();

        var settings = this.getSettings();
        if (settings.restoreTrafficSelection && settings.restoreTrafficValue !== this.$.map.shownTraffic) {
            settings.restoreTrafficValue = this.$.map.shownTraffic;
            settings.save();
        }
    },

    // ================================ Gesture Handlers ====================================================
    gesturestartHandler: function (inSender, e) {
        //enyo.log("gesturestartHandler started");
        this.previousScale = e.scale;
    },
    gesturechangeHandler: function (inSender, e) {
        //enyo.log("gesturechangeHandler started");
        var d = this.previousScale - e.scale;
        if (Math.abs(d) > 0.25) {
            var z = this.$.map.getZoom() + (d > 0 ? -1 : +1);
            this.$.map.setZoom(z);
            this.previousScale = e.scale;

            var settings = this.getSettings();
            if (settings.restorePosition) {
                console.log('saving position [gesture], zoom: ' + z);
                settings.restorePositionZoom = z;
                settings.save();
            }
        }
    },
    gestureendHandler: function (inSender, e) {
        //enyo.log("gestureendHandler started");
    },

    unloadHandler: function () {
        /* unloadHandler() - Disconnect SPP Device
        * Called when application is dismissed/closed
        */
        //make sure to disconnect from the SPP SERVICE!
        console.log("start unloading...");
        this.turnOffGps();
    }
})
